package com.ruoyi.system.domain;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

import com.baomidou.mybatisplus.annotation.TableField;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;

/**
 * 项目管理对象 project_manage
 *
 */
@Data
public class ProjectManage extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 主键id */
    private Long id;

    /** 项目编号 */
    @Excel(name = "项目编号")
    private String projectNumber;

    /** 项目名称 */
    @Excel(name = "项目名称")
    private String projectName;


    /** 项目成本 */
    @Excel(name = "项目成本")
    private BigDecimal projectCost;

    /** 项目类型 */
    //@Excel(name = "项目类型")
    private String projectType;

    /** 事业部负责人 */
    //@Excel(name = "事业部负责人")
    private Long departmentLeaderId;

    /** 项目经理 */
   // @Excel(name = "项目经理")
    private Long projectManagerId;
    // 事业部负责人名称(查询列表)
    @TableField(exist = false)
    @Excel(name = "事业部负责人")
    private String departmentLeaderName;

    // 项目经理名称(查询列表)
    @TableField(exist = false)
    @Excel(name = "项目经理")
    private String projectManagerName;

    // 查询项目成员名称(查询列表)
    @TableField(exist = false)
    @Excel(name = "项目成员")
    private String projectMemberNames;

    /** 预计开始时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "预计开始时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date startDate;

    /** 预计结束时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "预计结束时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date endDate;

    /** 项目描述 */
    @Excel(name = "项目描述")
    private String projectDescribe;

    /** 项目状态 */
    //@Excel(name = "项目状态")
    private String projectStatus;

    /** 立项时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "立项时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date createDate;

    /** 更新时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "更新时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date updateDate;

    /** 草稿箱（0-草稿 1-不是） */
    private String draft;

    /** 删除标记(0-存在 1-删除) */
    private String delFlag;


    // 项目成员(详情，新增)
    @TableField(exist = false)
    private List<Long> projectMemberIds;

    // 回款笔数
    @TableField(exist = false)
    private int repaymentCount;

    // 回款信息
    @TableField(exist = false)
    private List<ProjectRepayment> repaymentDetails;

    // 附件信息
    @TableField(exist = false)
    private List<ProjectAnnex> projectAnnexList;

    // 删除标记(0-存在 1-删除)
    public static final int NO_DELETE = 0;
    public static final int DELETE  = 1;

    // 草稿箱（0-草稿 1-不是）
    public static final int DRAFT  = 0;
    public static final int NOT_DRAFT  = 1;
}
